common/models/Prices.php
<?php

namespace common\models;

use Yii;

/**
 * This is the model class for table "prices".
 *
 * @property int $id
 * @property int $service_id
 * @property int $category_id
 * @property int $manufacturer_id
 * @property string $description
 * @property string $passenger
 * @property string $offroad
 *
 * @property Service $service
 * @property Categories $category
 * @property CarManufacturer $manufacturer
 */
class Prices extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'prices';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['service_id', 'category_id', 'manufacturer_id'], 'integer'],
            [['description', 'passenger', 'offroad'], 'string', 'max' => 300],
            [['service_id'], 'exist', 'skipOnError' => true, 'targetClass' => Service::className(), 'targetAttribute' => ['service_id' => 'id']],
            [['category_id'], 'exist', 'skipOnError' => true, 'targetClass' => Categories::className(), 'targetAttribute' => ['category_id' => 'id']],
            [['manufacturer_id'], 'exist', 'skipOnError' => true, 'targetClass' => CarManufacturer::className(), 'targetAttribute' => ['manufacturer_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'service_id' => 'Service ID',
            'category_id' => 'Category ID',
            'manufacturer_id' => 'Manufacturer ID',
            'description' => 'Description',
            'passenger' => 'Passenger',
            'offroad' => 'Offroad',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getService()
    {
        return $this->hasOne(Service::className(), ['id' => 'service_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getCategory()
    {
        return $this->hasOne(Categories::className(), ['id' => 'category_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getManufacturer()
    {
        return $this->hasOne(CarManufacturer::className(), ['id' => 'manufacturer_id']);
    }
}

backend/controllers/PricesController.php
<?php

namespace backend\controllers;

use backend\models\PricesControl;
use common\models\CarManufacturer;
use common\models\CarService;
use common\models\Categories;
use common\models\Prices;
use common\models\Service;
use Yii;
use yii\filters\VerbFilter;
use yii\helpers\ArrayHelper;
use yii\web\Controller;
use yii\web\NotFoundHttpException;

/**
 * PricesController implements the CRUD actions for Prices model.
 */
class PricesController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'verbs' => [
                'class'   => VerbFilter::className(),
                'actions' => [
                    'delete' => ['POST'],
                ],
            ],
        ];
    }
    
    /**
     * Lists all Prices models.
     *
     * @return mixed
     */
    public function actionIndex()
    {
        $searchModel = new PricesControl();
        $dataProvider = $searchModel->search(Yii::$app->request->queryParams);
        
        return $this->render(
            'index',
            [
                'searchModel'  => $searchModel,
                'dataProvider' => $dataProvider,
            ]
        );
    }
    
    /**
     * Displays a single Prices model.
     *
     * @param integer $id
     *
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionView($id)
    {
        return $this->render(
            'view',
            [
                'model' => $this->findModel($id),
            ]
        );
    }
    
    /**
     * Finds the Prices model based on its primary key value.
     * If the model is not found, a 404 HTTP exception will be thrown.
     *
     * @param integer $id
     *
     * @return Prices the loaded model
     * @throws NotFoundHttpException if the model cannot be found
     */
    protected function findModel($id)
    {
        if (($model = Prices::findOne($id)) !== null) {
            return $model;
        }
        
        throw new NotFoundHttpException('The requested page does not exist.');
    }
    
    /**
     * Creates a new Prices model.
     * If creation is successful, the browser will be redirected to the 'view' page.
     *
     * @return mixed
     */
    public function actionCreate()
    {
        $model = new Prices();
        
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }
        
        return $this->render(
            'create',
            [
                'model' => $model,
            ]
        );
    }
    
    /**
     * Updates an existing Prices model.
     * If update is successful, the browser will be redirected to the 'view' page.
     *
     * @param integer $id
     *
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionUpdate($id)
    {
        $model = $this->findModel($id);
        
        if ($model->load(Yii::$app->request->post()) && $model->save()) {
            return $this->redirect(['view', 'id' => $model->id]);
        }
        
        return $this->render(
            'update',
            [
                'model' => $model,
            ]
        );
    }
    
    /**
     * Deletes an existing Prices model.
     * If deletion is successful, the browser will be redirected to the 'index' page.
     *
     * @param integer $id
     *
     * @return mixed
     * @throws NotFoundHttpException if the model cannot be found
     */
    public function actionDelete($id)
    {
        $this->findModel($id)->delete();
        
        return $this->redirect(['index']);
    }
    
    public function actionGetCategories($serviceId)
    {
        $categoriesId =
            ArrayHelper::map(
                CarService::find()
                    ->where(['service_id' => $serviceId])
                    ->asArray()
                    ->all(),
                'id',
                'category_id'
            );
        $modelCategory = Categories::find()
            ->where(['id' => $categoriesId])
            ->asArray()
            ->all();
        
        if ($modelCategory !== null) {
            foreach ($modelCategory as $category) {
                echo "<option value='{$category['id']}'>{$category['title']}</option>";
            }
        }
    }
    
    public function actionGetManufacturer($serviceId)
    {
        $manufacturerId =
            json_decode(
                Service::findOne(['id' => $serviceId])->car_manufacturer_id,
                true
            );
        var_dump($manufacturerId);
        
        $model = CarManufacturer::find()
            ->where(['id' => $manufacturerId])
            ->asArray()
            ->all();
        
        var_dump($model);
        
        if ($model !== null) {
            foreach ($model as $manufacturer) {
                echo "<option value='{$manufacturer['id']}'>{$manufacturer['name']}</option>";
            }
        }
    }
}

backend/views/prices/_form.php
<?php

use common\models\Service;
use kartik\select2\Select2;
use yii\helpers\ArrayHelper;
use yii\helpers\Html;
use yii\helpers\Url;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model common\models\Prices */
/* @var $form yii\widgets\ActiveForm */
?>

<div class="prices-form">
    <?php $form = ActiveForm::begin(); ?>

    <div class="col-xs-12">
        <div class="row">
            <div class="col-xs-6">
                <?php
                
                $servicesModel =
                    ArrayHelper::map(
                        Service::find()->all(),
                        'id',
                        'name'
                    );
                
                echo $form->field($model, 'service_id')->widget(
                    Select2::class,
                    [
                        'data'    => $servicesModel,
                        'options' =>
                            [
                                'placeholder' => 'Services',
                                'onChange'    =>
                                    Sprintf(
                                    '$.get("%s",{
                                             serviceId: $(this).val() }
                                             ).done(function(data){
                                              $("#prices-category_id").html( data );
                                                }
                                              );
                                              $.get("%s",{
                                             serviceId: $(this).val() }
                                             ).done(function(data){
                                              $("#prices-manufacturer_id").html( data );
                                                }
                                              );
                                       ',
                                    Url::toRoute(['/prices/get-categories']),
                                    Url::toRoute(['/prices/get-manufacturer'])
                                ),
                            ],
                    ]
                );
                ?>
            </div>
            <div class="col-xs-6">
                <?= $form->field($model, 'category_id')->widget(
                    Select2::class,
                    [
                        'data'    => [],
                        'options' =>
                            [
                                'placeholder' => 'Categories',
                            ],
                    ]
                );
                ?>
            </div>
        </div>
    </div>

    <div class="col-xs-12">
        <?= $form->field($model, 'manufacturer_id')->widget(
            Select2::class,
            [
                'data'    => [],
                'options' =>
                    [
                        'placeholder' => 'Manufacturer',
                    ],
            ]
        );
        ?>
    </div>

    <div class="col-xs-12">
        <div class="row">
            <div class="col-xs-6">
                <?= $form->field($model, 'passenger')->textInput(['maxlength' => true]) ?>
            </div>
            <div class="col-xs-6">
                <?= $form->field($model, 'offroad')->textInput(['maxlength' => true]) ?>
            </div>
        </div>
    </div>

    <div class="col-xs-12">
        <?= $form->field($model, 'description')->textarea(['row' => 3]) ?>
    </div>

    <div class="form-group">
        <?= Html::submitButton('Save', ['class' => 'btn btn-success']) ?>
    </div>
    
    <?php ActiveForm::end(); ?>
</div>

backend/views/prices/create.php
<?php

use yii\helpers\Html;


/* @var $this yii\web\View */
/* @var $model common\models\Prices */

$this->title = 'Create Prices';
$this->params['breadcrumbs'][] = ['label' => 'Prices', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="prices-create">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/prices/index.php
<?php

use backend\modules\grid\GridView;
use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $searchModel backend\models\PricesControl */
/* @var $dataProvider yii\data\ActiveDataProvider */

$this->title = 'Prices';
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="prices-index">

    <h1><?= Html::encode($this->title) ?></h1>
    
    <?= GridView::widget(
        [
            'dataProvider' => $dataProvider,
            'filterModel'  => $searchModel,
            'columns'      =>
                [
                    ['class' => 'yii\grid\SerialColumn'],
                    
                    'id',
                    'service_id',
                    'category_id',
                    'manufacturer_id',
                    'description',
                    'passenger',
                    'offroad',
                    
                    ['class' => 'yii\grid\ActionColumn'],
                ],
        ]
    ); ?>
</div>

backend/views/prices/update.php
<?php

use yii\helpers\Html;

/* @var $this yii\web\View */
/* @var $model common\models\Prices */

$this->title = 'Update Prices: ' . $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Prices', 'url' => ['index']];
$this->params['breadcrumbs'][] = ['label' => $model->id, 'url' => ['view', 'id' => $model->id]];
$this->params['breadcrumbs'][] = 'Update';
?>
<div class="prices-update">

    <h1><?= Html::encode($this->title) ?></h1>

    <?= $this->render('_form', [
        'model' => $model,
    ]) ?>

</div>

backend/views/prices/view.php
<?php

use yii\helpers\Html;
use yii\widgets\DetailView;

/* @var $this yii\web\View */
/* @var $model common\models\Prices */

$this->title = $model->id;
$this->params['breadcrumbs'][] = ['label' => 'Prices', 'url' => ['index']];
$this->params['breadcrumbs'][] = $this->title;
?>
<div class="prices-view">

    <h1><?= Html::encode($this->title) ?></h1>

    <p>
        <?= Html::a('Update', ['update', 'id' => $model->id], ['class' => 'btn btn-primary']) ?>
        <?= Html::a('Delete', ['delete', 'id' => $model->id], [
            'class' => 'btn btn-danger',
            'data' => [
                'confirm' => 'Are you sure you want to delete this item?',
                'method' => 'post',
            ],
        ]) ?>
    </p>

    <?= DetailView::widget([
        'model' => $model,
        'attributes' => [
            'id',
            'service_id',
            'category_id',
            'manufacturer_id',
            'description',
            'passenger',
            'offroad',
        ],
    ]) ?>

</div>